// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

#include <stdint.h>

#ifdef _MSC_VER
#define DLLEXPORT __declspec(dllexport)
#else
#define DLLEXPORT __attribute__((visibility("default")))
#endif

struct DotNetRuntimeContractDescriptor
{
    uint64_t magic;
    uint32_t flags;
    const uint32_t descriptor_size;
    const char *descriptor;
    const uint32_t pointer_data_count;
    uint32_t pad0;
    const uintptr_t *pointer_data;
};

extern const uintptr_t contractDescriptorPointerData[];

DLLEXPORT struct DotNetRuntimeContractDescriptor DotNetRuntimeContractDescriptor;

DLLEXPORT struct DotNetRuntimeContractDescriptor DotNetRuntimeContractDescriptor = {
    .magic = 0x0043414443434e44ull, // "DNCCDAC\0"
    .flags = 0x00000001,
    .descriptor_size = 3182,
    .descriptor = "{\"version\":0,\"baseline\":\"empty\",\"types\":{\"Thread\":{\"Id\":16,\"OSId\":296,\"State\":0,\"PreemptiveGCDisabled\":4,\"RuntimeThreadLocals\":32,\"Frame\":8,\"ExceptionTracker\":352,\"GCHandle\":[304,\"GCHandle\"],\"LastThrownObject\":[336,\"GCHandle\"],\"LinkNext\":[112,\"pointer\"]},\"ThreadStore\":{\"FirstThreadLink\":160,\"ThreadCount\":184,\"UnstartedCount\":188,\"BackgroundCount\":192,\"PendingCount\":196,\"DeadCount\":200},\"RuntimeThreadLocals\":{\"AllocContext\":[0,\"AllocContext\"]},\"GCAllocContext\":{\"Pointer\":0,\"Limit\":8},\"Exception\":{\"_message\":16,\"_innerException\":32,\"_stackTrace\":48,\"_watsonBuckets\":56,\"_stackTraceString\":64,\"_remoteStackTraceString\":72,\"_HResult\":108,\"_xcode\":104},\"ExceptionInfo\":{\"ThrownObject\":8,\"PreviousNestedInfo\":0},\"GCHandle\":{\"!\":8},\"Object\":{\"m_pMethTab\":0},\"String\":{\"m_FirstChar\":12,\"m_StringLength\":8},\"Array\":{\"!\":16,\"m_NumComponents\":8},\"InteropSyncBlockInfo\":{},\"SyncBlock\":{\"InteropInfo\":56},\"SyncTableEntry\":{\"!\":16,\"SyncBlock\":0},\"Module\":{\"Assembly\":312,\"Base\":288,\"Flags\":296,\"LoaderAllocator\":248,\"ThunkHeap\":1032,\"DynamicMetadata\":1120,\"Path\":272,\"FieldDefToDescMap\":720,\"ManifestModuleReferencesMap\":40,\"MemberRefToDescMap\":72,\"MethodDefToDescMap\":656,\"TypeDefToMethodTableMap\":624,\"TypeRefToMethodTableMap\":8,\"MethodDefToILCodeVersioningStateMap\":688},\"ModuleLookupMap\":{\"TableData\":8},\"MethodTable\":{\"MTFlags\":0,\"BaseSize\":4,\"MTFlags2\":8,\"EEClassOrCanonMT\":40,\"Module\":24,\"ParentMethodTable\":16,\"NumInterfaces\":14,\"NumVirtuals\":12,\"PerInstInfo\":48},\"EEClass\":{\"MethodTable\":16,\"NumMethods\":52,\"CorTypeAttr\":40,\"InternalCorElementType\":48,\"NumNonVirtualSlots\":62},\"ArrayClass\":{\"Rank\":72},\"GenericsDictInfo\":{\"NumTypeArgs\":6},\"TypeDesc\":{\"TypeAndFlags\":0},\"ParamTypeDesc\":{\"TypeArg\":16},\"TypeVarTypeDesc\":{\"Module\":16,\"Token\":40},\"FnPtrTypeDesc\":{\"NumArgs\":24,\"CallConv\":28,\"RetAndArgTypes\":32,\"LoaderModule\":16},\"DynamicMetadata\":{\"Size\":0,\"Data\":4},\"MethodDesc\":{\"ChunkIndex\":2,\"Slot\":4,\"Flags\":6,\"Flags3AndTokenRemainder\":0},\"MethodDescChunk\":{\"!\":24,\"MethodTable\":0,\"Next\":8,\"Size\":16,\"Count\":17,\"FlagsAndTokenRange\":18},\"InstantiatedMethodDesc\":{\"PerInstInfo\":24,\"Flags2\":32,\"NumGenericArgs\":34},\"StoredSigMethodDesc\":{\"Sig\":16,\"cSig\":24,\"ExtendedFlags\":28},\"DynamicMethodDesc\":{\"MethodName\":32}},\"globals\":{\"MethodDescTokenRemainderBitCount\":[\"0xc\",\"uint8\"],\"FeatureEHFunclets\":[\"0x1\",\"uint8\"],\"FeatureCOMInterop\":[\"0x0\",\"uint8\"],\"ObjectToMethodTableUnmask\":[\"0x7\",\"uint8\"],\"SOSBreakingChangeVersion\":[\"0x5\",\"uint8\"],\"DirectorySeparator\":[\"0x2f\",\"uint8\"],\"MethodDescAlignment\":[\"0x8\",\"uint64\"],\"ObjectHeaderSize\":[\"0x8\",\"uint64\"],\"SyncBlockValueToObjectOffset\":[\"0x4\",\"uint16\"],\"AppDomain\":[[1],\"pointer\"],\"ThreadStore\":[[2],\"pointer\"],\"FinalizerThread\":[[3],\"pointer\"],\"GCThread\":[[4],\"pointer\"],\"ArrayBoundsZero\":[[5],\"pointer\"],\"ExceptionMethodTable\":[[6],\"pointer\"],\"FreeObjectMethodTable\":[[7],\"pointer\"],\"ObjectMethodTable\":[[8],\"pointer\"],\"ObjectArrayMethodTable\":[[9],\"pointer\"],\"StringMethodTable\":[[10],\"pointer\"],\"SyncTableEntries\":[[11],\"pointer\"],\"MiniMetaDataBuffAddress\":[[12],\"pointer\"],\"MiniMetaDataBuffMaxSize\":[[13],\"pointer\"]},\"contracts\":{\"DacStreams\":1,\"EcmaMetadata\":1,\"Exception\":1,\"Loader\":1,\"Object\":1,\"RuntimeTypeSystem\":1,\"Thread\":1}}",
    .pointer_data_count = 14,
    .pointer_data = &contractDescriptorPointerData[0],
};
